# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def read_history(*, channel: abcs.InputChannel, max_id: int) -> Request[bool]:
    _buffer = bytearray(b'7I\x10\xcc')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', max_id)
    return Request(b'' + _buffer)
def delete_messages(*, channel: abcs.InputChannel, id: Sequence[int]) -> Request[abcs.messages.AffectedMessages]:
    _buffer = bytearray(b'N\xfd\xc1\x84')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def report_spam(*, channel: abcs.InputChannel, participant: abcs.InputPeer, id: Sequence[int]) -> Request[bool]:
    _buffer = bytearray(b'\x15\x83J\xf4')
    channel._write_boxed_to(_buffer)
    participant._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def get_messages(*, channel: abcs.InputChannel, id: Sequence[abcs.InputMessage]) -> Request[abcs.messages.Messages]:
    _buffer = bytearray(b'#\x9a\x8c\xad')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    for _t0 in id:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_participants(*, channel: abcs.InputChannel, filter: abcs.ChannelParticipantsFilter, offset: int, limit: int, hash: int) -> Request[abcs.channels.ChannelParticipants]:
    _buffer = bytearray(b'\xd0\xd9\xcew')
    channel._write_boxed_to(_buffer)
    filter._write_boxed_to(_buffer)
    _buffer += struct.pack('<iiq', offset, limit, hash)
    return Request(b'' + _buffer)
def get_participant(*, channel: abcs.InputChannel, participant: abcs.InputPeer) -> Request[abcs.channels.ChannelParticipant]:
    _buffer = bytearray(b'\xc6l\xab\xa0')
    channel._write_boxed_to(_buffer)
    participant._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_channels(*, id: Sequence[abcs.InputChannel]) -> Request[abcs.messages.Chats]:
    _buffer = bytearray(b'\xbbk\x7f\n')
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    for _t0 in id:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_full_channel(*, channel: abcs.InputChannel) -> Request[abcs.messages.ChatFull]:
    _buffer = bytearray(b'\tjs\x08')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def create_channel(*, broadcast: bool, megagroup: bool, for_import: bool, forum: bool, title: str, about: str, geo_point: Optional[abcs.InputGeoPoint], address: Optional[str], ttl_period: Optional[int]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x07g\x00\x91')
    flags = (1 if broadcast else 0) | (2 if megagroup else 0) | (8 if for_import else 0) | (32 if forum else 0) | (0 if geo_point is None else 4) | (0 if address is None else 4) | (0 if ttl_period is None else 16)
    _buffer += struct.pack('<I', flags)
    serialize_bytes_to(_buffer, title.encode('utf-8'))
    serialize_bytes_to(_buffer, about.encode('utf-8'))
    if geo_point is not None:
      geo_point._write_boxed_to(_buffer)
    if address is not None:
      serialize_bytes_to(_buffer, address.encode('utf-8'))
    if ttl_period is not None:
      _buffer += struct.pack(f'<i', ttl_period)
    return Request(b'' + _buffer)
def edit_admin(*, channel: abcs.InputChannel, user_id: abcs.InputUser, admin_rights: abcs.ChatAdminRights, rank: str) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x02\x89<\xd3')
    channel._write_boxed_to(_buffer)
    user_id._write_boxed_to(_buffer)
    admin_rights._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, rank.encode('utf-8'))
    return Request(b'' + _buffer)
def edit_title(*, channel: abcs.InputChannel, title: str) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xd0\xecmV')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, title.encode('utf-8'))
    return Request(b'' + _buffer)
def edit_photo(*, channel: abcs.InputChannel, photo: abcs.InputChatPhoto) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xc9W.\xf1')
    channel._write_boxed_to(_buffer)
    photo._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def check_username(*, channel: abcs.InputChannel, username: str) -> Request[bool]:
    _buffer = bytearray(b',\xbd\xe6\x10')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, username.encode('utf-8'))
    return Request(b'' + _buffer)
def update_username(*, channel: abcs.InputChannel, username: str) -> Request[bool]:
    _buffer = bytearray(b'\xde\xb3\x145')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, username.encode('utf-8'))
    return Request(b'' + _buffer)
def join_channel(*, channel: abcs.InputChannel) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xc5$\xb5$')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def leave_channel(*, channel: abcs.InputChannel) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x95\xaa6\xf8')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def invite_to_channel(*, channel: abcs.InputChannel, users: Sequence[abcs.InputUser]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'l:\x9f\x19')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(users))
    for _t0 in users:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def delete_channel(*, channel: abcs.InputChannel) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xe3\x1f\x11\xc0')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def export_message_link(*, grouped: bool, thread: bool, channel: abcs.InputChannel, id: int) -> Request[abcs.ExportedMessageLink]:
    _buffer = bytearray(b'\xeb\xad?\xe6')
    flags = (1 if grouped else 0) | (2 if thread else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', id)
    return Request(b'' + _buffer)
def toggle_signatures(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x06\xb6i\x1f')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def get_admined_public_channels(*, by_location: bool, check_limit: bool) -> Request[abcs.messages.Chats]:
    _buffer = bytearray(b'\xaf6\xb0\xf8')
    flags = (1 if by_location else 0) | (2 if check_limit else 0)
    _buffer += struct.pack('<I', flags)
    return Request(b'' + _buffer)
def edit_banned(*, channel: abcs.InputChannel, participant: abcs.InputPeer, banned_rights: abcs.ChatBannedRights) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x81\xcd\xe6\x96')
    channel._write_boxed_to(_buffer)
    participant._write_boxed_to(_buffer)
    banned_rights._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_admin_log(*, channel: abcs.InputChannel, q: str, events_filter: Optional[abcs.ChannelAdminLogEventsFilter], admins: Optional[Sequence[abcs.InputUser]], max_id: int, min_id: int, limit: int) -> Request[abcs.channels.AdminLogResults]:
    _buffer = bytearray(b'\x80\xf4\xdd3')
    flags = (0 if events_filter is None else 1) | (0 if admins is None else 2)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, q.encode('utf-8'))
    if events_filter is not None:
      events_filter._write_boxed_to(_buffer)
    if admins is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(admins))
      for _t0 in admins:
        _t0._write_boxed_to(_buffer)
    _buffer += struct.pack('<qqi', max_id, min_id, limit)
    return Request(b'' + _buffer)
def set_stickers(*, channel: abcs.InputChannel, stickerset: abcs.InputStickerSet) -> Request[bool]:
    _buffer = bytearray(b'\xf9\xa4\x8c\xea')
    channel._write_boxed_to(_buffer)
    stickerset._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def read_message_contents(*, channel: abcs.InputChannel, id: Sequence[int]) -> Request[bool]:
    _buffer = bytearray(b'8\xdc\xb5\xea')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def delete_history(*, for_everyone: bool, channel: abcs.InputChannel, max_id: int) -> Request[abcs.Updates]:
    _buffer = bytearray(b'G\x96\xaa\x9b')
    flags = (1 if for_everyone else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', max_id)
    return Request(b'' + _buffer)
def toggle_pre_history_hidden(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'L\xb9\xbb\xea')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def get_left_channels(*, offset: int) -> Request[abcs.messages.Chats]:
    _buffer = bytearray(b'\xc0\xecA\x83')
    _buffer += struct.pack('<i', offset)
    return Request(b'' + _buffer)
def get_groups_for_discussion() -> Request[abcs.messages.Chats]:
    _buffer = bytearray(b'x\xd3\xda\xf5')
    return Request(b'' + _buffer)
def set_discussion_group(*, broadcast: abcs.InputChannel, group: abcs.InputChannel) -> Request[bool]:
    _buffer = bytearray(b'\xb2+X@')
    broadcast._write_boxed_to(_buffer)
    group._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def edit_creator(*, channel: abcs.InputChannel, user_id: abcs.InputUser, password: abcs.InputCheckPasswordSrp) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x1f\xcd8\x8f')
    channel._write_boxed_to(_buffer)
    user_id._write_boxed_to(_buffer)
    password._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def edit_location(*, channel: abcs.InputChannel, geo_point: abcs.InputGeoPoint, address: str) -> Request[bool]:
    _buffer = bytearray(b'm?\xe6X')
    channel._write_boxed_to(_buffer)
    geo_point._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, address.encode('utf-8'))
    return Request(b'' + _buffer)
def toggle_slow_mode(*, channel: abcs.InputChannel, seconds: int) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xf0\x9e\xd4\xed')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', seconds)
    return Request(b'' + _buffer)
def get_inactive_channels() -> Request[abcs.messages.InactiveChats]:
    _buffer = bytearray(b'\xee1\xe8\x11')
    return Request(b'' + _buffer)
def convert_to_gigagroup(*, channel: abcs.InputChannel) -> Request[abcs.Updates]:
    _buffer = bytearray(b'i\x0c)\x0b')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def view_sponsored_message(*, channel: abcs.InputChannel, random_id: _bytes) -> Request[bool]:
    _buffer = bytearray(b'\x94\xdb\xae\xbe')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, random_id)
    return Request(b'' + _buffer)
def get_sponsored_messages(*, channel: abcs.InputChannel) -> Request[abcs.messages.SponsoredMessages]:
    _buffer = bytearray(b'\xbf\x0f!\xec')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_send_as(*, peer: abcs.InputPeer) -> Request[abcs.channels.SendAsPeers]:
    _buffer = bytearray(b'\xeep\xc7\r')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def delete_participant_history(*, channel: abcs.InputChannel, participant: abcs.InputPeer) -> Request[abcs.messages.AffectedHistory]:
    _buffer = bytearray(b'\xdbDu6')
    channel._write_boxed_to(_buffer)
    participant._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def toggle_join_to_send(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x80\x95\xcb\xe4')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def toggle_join_request(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xb6\x85)L')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def reorder_usernames(*, channel: abcs.InputChannel, order: Sequence[str]) -> Request[bool]:
    _buffer = bytearray(b'\x1d\xed\\\xb4')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(order))
    for _t0 in order:
      serialize_bytes_to(_buffer, _t0.encode('utf-8'))
    return Request(b'' + _buffer)
def toggle_username(*, channel: abcs.InputChannel, username: str, active: bool) -> Request[bool]:
    _buffer = bytearray(b'\x05A\xf2P')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, username.encode('utf-8'))
    _buffer += struct.pack('<I', active)
    return Request(b'' + _buffer)
def deactivate_all_usernames(*, channel: abcs.InputChannel) -> Request[bool]:
    _buffer = bytearray(b'\xd3]$\n')
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def toggle_forum(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b')\x8b)\xa4')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def create_forum_topic(*, channel: abcs.InputChannel, title: str, icon_color: Optional[int], icon_emoji_id: Optional[int], random_id: int, send_as: Optional[abcs.InputPeer]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'$\x02\x0c\xf4')
    flags = (0 if icon_color is None else 1) | (0 if icon_emoji_id is None else 8) | (0 if send_as is None else 4)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, title.encode('utf-8'))
    if icon_color is not None:
      _buffer += struct.pack(f'<i', icon_color)
    if icon_emoji_id is not None:
      _buffer += struct.pack(f'<q', icon_emoji_id)
    _buffer += struct.pack('<q', random_id)
    if send_as is not None:
      send_as._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_forum_topics(*, channel: abcs.InputChannel, q: Optional[str], offset_date: int, offset_id: int, offset_topic: int, limit: int) -> Request[abcs.messages.ForumTopics]:
    _buffer = bytearray(b'\xd1`\xe5\r')
    flags = (0 if q is None else 1)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    if q is not None:
      serialize_bytes_to(_buffer, q.encode('utf-8'))
    _buffer += struct.pack('<iiii', offset_date, offset_id, offset_topic, limit)
    return Request(b'' + _buffer)
def get_forum_topics_by_id(*, channel: abcs.InputChannel, topics: Sequence[int]) -> Request[abcs.messages.ForumTopics]:
    _buffer = bytearray(b'\xb9\x1e\x83\xb0')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(topics))
    _buffer += struct.pack(f'<{len(topics)}i', *topics)
    return Request(b'' + _buffer)
def edit_forum_topic(*, channel: abcs.InputChannel, topic_id: int, title: Optional[str], icon_emoji_id: Optional[int], closed: Optional[bool], hidden: Optional[bool]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x85\xa1\xdf\xf4')
    flags = (0 if title is None else 1) | (0 if icon_emoji_id is None else 2) | (0 if closed is None else 4) | (0 if hidden is None else 8)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', topic_id)
    if title is not None:
      serialize_bytes_to(_buffer, title.encode('utf-8'))
    if icon_emoji_id is not None:
      _buffer += struct.pack(f'<q', icon_emoji_id)
    if closed is not None:
      _buffer += struct.pack(f'<I', (0x997275b5 if closed else 0xbc799737))
    if hidden is not None:
      _buffer += struct.pack(f'<I', (0x997275b5 if hidden else 0xbc799737))
    return Request(b'' + _buffer)
def update_pinned_forum_topic(*, channel: abcs.InputChannel, topic_id: int, pinned: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'&\x90-l')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<iI', topic_id, pinned)
    return Request(b'' + _buffer)
def delete_topic_history(*, channel: abcs.InputChannel, top_msg_id: int) -> Request[abcs.messages.AffectedHistory]:
    _buffer = bytearray(b'-_C4')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', top_msg_id)
    return Request(b'' + _buffer)
def reorder_pinned_forum_topics(*, force: bool, channel: abcs.InputChannel, order: Sequence[int]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x8f\xa1P)')
    flags = (1 if force else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(order))
    _buffer += struct.pack(f'<{len(order)}i', *order)
    return Request(b'' + _buffer)
def toggle_anti_spam(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xeb\xe4\xf3h')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def report_anti_spam_false_positive(*, channel: abcs.InputChannel, msg_id: int) -> Request[bool]:
    _buffer = bytearray(b'\x93\xa6P\xa8')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', msg_id)
    return Request(b'' + _buffer)
def toggle_participants_hidden(*, channel: abcs.InputChannel, enabled: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'Txnj')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', enabled)
    return Request(b'' + _buffer)
def click_sponsored_message(*, channel: abcs.InputChannel, random_id: _bytes) -> Request[bool]:
    _buffer = bytearray(b'\x93\xbc\xaf\x18')
    channel._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, random_id)
    return Request(b'' + _buffer)
